Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels) Summary: [Constants](https://developer.android.com/reference/java/net/HttpURLConnection#constants) \| [Fields](https://developer.android.com/reference/java/net/HttpURLConnection#lfields) \| [Inherited Fields](https://developer.android.com/reference/java/net/HttpURLConnection#inhfields) \| [Protected Ctors](https://developer.android.com/reference/java/net/HttpURLConnection#proctors) \| [Methods](https://developer.android.com/reference/java/net/HttpURLConnection#pubmethods) \| [Inherited Methods](https://developer.android.com/reference/java/net/HttpURLConnection#inhmethods)

# HttpURLConnection

` public abstract class HttpURLConnection `   
` ` ` extends https://developer.android.com/reference/java/net/URLConnection ` ` `

|---|---|---|
| [java.lang.Object](https://developer.android.com/reference/java/lang/Object) |||
| ↳ | [java.net.URLConnection](https://developer.android.com/reference/java/net/URLConnection) ||
|   | ↳ | java.net.HttpURLConnection |

Known direct subclasses [HttpsURLConnection](https://developer.android.com/reference/javax/net/ssl/HttpsURLConnection) [HttpsURLConnection](https://developer.android.com/reference/javax/net/ssl/HttpsURLConnection) `HttpsURLConnection` extends `HttpURLConnection` with support for https-specific features.   

*** ** * ** ***

A URLConnection with support for HTTP-specific features. See [the spec](http://www.w3.org/pub/WWW/Protocols/) for details.

<br />

Uses of this class follow a pattern:

1. Obtain a new `HttpURLConnection` by calling `https://developer.android.com/reference/java/net/URL#openConnection()` and casting the result to `HttpURLConnection`.
2. Prepare the request. The primary property of a request is its URI. Request headers may also include metadata such as credentials, preferred content types, and session cookies.
3. Optionally upload a request body. Instances must be configured with `https://developer.android.com/reference/java/net/URLConnection#setDoOutput(boolean)` if they include a request body. Transmit data by writing to the stream returned by `https://developer.android.com/reference/java/net/URLConnection#getOutputStream()`.
4. Read the response. Response headers typically include metadata such as the response body's content type and length, modified dates and session cookies. The response body may be read from the stream returned by `https://developer.android.com/reference/java/net/URLConnection#getInputStream()`. If the response has no body, that method returns an empty stream.
5. Disconnect. Once the response body has been read, the `HttpURLConnection` should be closed by calling `https://developer.android.com/reference/java/net/HttpURLConnection#disconnect()`. Disconnecting releases the resources held by a connection so they may be closed or reused.

For example, to retrieve the webpage at `http://www.android.com/`:

    URL url = new URL("http://www.android.com/");
      HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
      try {
        InputStream in = new BufferedInputStream(urlConnection.getInputStream());
        readStream(in);
      } finally {
        urlConnection.disconnect();
      }

### Secure Communication with HTTPS

Calling `https://developer.android.com/reference/java/net/URL#openConnection()` on a URL with the "https" scheme will return an `HttpsURLConnection`, which allows for overriding the default `https://developer.android.com/reference/javax/net/ssl/HostnameVerifier` and `https://developer.android.com/reference/javax/net/ssl/SSLSocketFactory`. An application-supplied `SSLSocketFactory` created from an `https://developer.android.com/reference/javax/net/ssl/SSLContext` can provide a custom `https://developer.android.com/reference/javax/net/ssl/X509TrustManager` for verifying certificate chains and a custom `https://developer.android.com/reference/javax/net/ssl/X509KeyManager` for supplying client certificates. See `https://developer.android.com/reference/javax/net/ssl/HttpsURLConnection` for more details.

### Response Handling

`HttpURLConnection` will follow up to five HTTP redirects. It will follow redirects from one origin server to another. This implementation doesn't follow redirects from HTTPS to HTTP or vice versa.

If the HTTP response indicates that an error occurred, `https://developer.android.com/reference/java/net/URLConnection#getInputStream()` will throw an `https://developer.android.com/reference/java/io/IOException`. Use `https://developer.android.com/reference/java/net/HttpURLConnection#getErrorStream()` to read the error response. The headers can be read in the normal way using `https://developer.android.com/reference/java/net/URLConnection#getHeaderFields()`,

### Posting Content

To upload data to a web server, configure the connection for output using `https://developer.android.com/reference/java/net/URLConnection#setDoOutput(boolean)`.

For best performance, you should call either `https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(int)` when the body length is known in advance, or `https://developer.android.com/reference/java/net/HttpURLConnection#setChunkedStreamingMode(int)` when it is not. Otherwise `HttpURLConnection` will be forced to buffer the complete request body in memory before it is transmitted, wasting (and possibly exhausting) heap and increasing latency.

For example, to perform an upload:

    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
      try {
        urlConnection.setDoOutput(true);
        urlConnection.setChunkedStreamingMode(0);

        OutputStream out = new BufferedOutputStream(urlConnection.getOutputStream());
        writeStream(out);

        InputStream in = new BufferedInputStream(urlConnection.getInputStream());
        readStream(in);
      } finally {
        urlConnection.disconnect();
      }

### Performance

The input and output streams returned by this class are **not buffered** . Most callers should wrap the returned streams with `https://developer.android.com/reference/java/io/BufferedInputStream` or `https://developer.android.com/reference/java/io/BufferedOutputStream`. Callers that do only bulk reads or writes may omit buffering.

When transferring large amounts of data to or from a server, use streams to limit how much data is in memory at once. Unless you need the entire body to be in memory at once, process it as a stream (rather than storing the complete body as a single byte array or string).

To reduce latency, this class may reuse the same underlying `Socket` for multiple request/response pairs. As a result, HTTP connections may be held open longer than necessary. Calls to `https://developer.android.com/reference/java/net/HttpURLConnection#disconnect()` may return the socket to a pool of connected sockets.

By default, this implementation of `HttpURLConnection` requests that servers use gzip compression and it automatically decompresses the data for callers of `https://developer.android.com/reference/java/net/URLConnection#getInputStream()`. The Content-Encoding and Content-Length response headers are cleared in this case. Gzip compression can be disabled by setting the acceptable encodings in the request header:

    urlConnection.setRequestProperty("Accept-Encoding", "identity");

Setting the Accept-Encoding request header explicitly disables automatic decompression and leaves the response headers intact; callers must handle decompression as needed, according to the Content-Encoding header of the response.

`https://developer.android.com/reference/java/net/URLConnection#getContentLength()` returns the number of bytes transmitted and cannot be used to predict how many bytes can be read from `https://developer.android.com/reference/java/net/URLConnection#getInputStream()` for compressed streams. Instead, read that stream until it is exhausted, i.e. when `https://developer.android.com/reference/java/io/InputStream#read()` returns -1.

### Handling Network Sign-On

Some Wi-Fi networks block Internet access until the user clicks through a sign-on page. Such sign-on pages are typically presented by using HTTP redirects. You can use `https://developer.android.com/reference/java/net/URLConnection#getURL()` to test if your connection has been unexpectedly redirected. This check is not valid until **after** the response headers have been received, which you can trigger by calling `https://developer.android.com/reference/java/net/URLConnection#getHeaderFields()` or `https://developer.android.com/reference/java/net/URLConnection#getInputStream()`. For example, to check that a response was not redirected to an unexpected host:

    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
      try {
        InputStream in = new BufferedInputStream(urlConnection.getInputStream());
        if (!url.getHost().equals(urlConnection.getURL().getHost())) {
          // we were redirected! Kick the user out to the browser to sign on?
        }
        ...
      } finally {
        urlConnection.disconnect();
      }

### HTTP Authentication

`HttpURLConnection` supports [HTTP basic authentication](http://www.ietf.org/rfc/rfc2617). Use `https://developer.android.com/reference/java/net/Authenticator` to set the VM-wide authentication handler:

    Authenticator.setDefault(new Authenticator() {
        protected PasswordAuthentication getPasswordAuthentication() {
          return new PasswordAuthentication(username, password.toCharArray());
        }
      });

Unless paired with HTTPS, this is **not** a secure mechanism for user authentication. In particular, the username, password, request and response are all transmitted over the network without encryption.

### Sessions with Cookies

To establish and maintain a potentially long-lived session between client and server, `HttpURLConnection` includes an extensible cookie manager. Enable VM-wide cookie management using `https://developer.android.com/reference/java/net/CookieHandler` and `https://developer.android.com/reference/java/net/CookieManager`:

    CookieManager cookieManager = new CookieManager();
      CookieHandler.setDefault(cookieManager);

By default, `CookieManager` accepts cookies from the [origin server](http://www.w3.org/Protocols/rfc2616/rfc2616-sec1.html) only. Two other policies are included: `https://developer.android.com/reference/java/net/CookiePolicy#ACCEPT_ALL` and `https://developer.android.com/reference/java/net/CookiePolicy#ACCEPT_NONE`. Implement `https://developer.android.com/reference/java/net/CookiePolicy` to define a custom policy.

The default `CookieManager` keeps all accepted cookies in memory. It will forget these cookies when the VM exits. Implement `https://developer.android.com/reference/java/net/CookieStore` to define a custom cookie store.

In addition to the cookies set by HTTP responses, you may set cookies programmatically. To be included in HTTP request headers, cookies must have the domain and path properties set.

By default, new instances of `HttpCookie` work only with servers that support [RFC 2965](http://www.ietf.org/rfc/rfc2965.txt) cookies. Many web servers support only the older specification, [RFC 2109](http://www.ietf.org/rfc/rfc2109.txt). For compatibility with the most web servers, set the cookie version to 0.

For example, to receive `www.twitter.com` in French:

    HttpCookie cookie = new HttpCookie("lang", "fr");
      cookie.setDomain("twitter.com");
      cookie.setPath("/");
      cookie.setVersion(0);
      cookieManager.getCookieStore().add(new URI("http://twitter.com/"), cookie);

### HTTP Methods

`HttpURLConnection` uses the `GET` method by default. It will use `POST` if `https://developer.android.com/reference/java/net/URLConnection#setDoOutput(boolean)` has been called. Other HTTP methods (`OPTIONS`, `HEAD`, `PUT`, `DELETE` and `TRACE`) can be used with `https://developer.android.com/reference/java/net/HttpURLConnection#setRequestMethod(java.lang.String)`.

### Proxies

By default, this class will connect directly to the [origin server](http://www.w3.org/Protocols/rfc2616/rfc2616-sec1.html). It can also connect via an `https://developer.android.com/reference/java/net/Proxy.Type#HTTP` or `https://developer.android.com/reference/java/net/Proxy.Type#SOCKS` proxy. To use a proxy, use `https://developer.android.com/reference/java/net/URL#openConnection(java.net.Proxy)` when creating the connection.

### IPv6 Support

This class includes transparent support for IPv6. For hosts with both IPv4 and IPv6 addresses, it will attempt to connect to each of a host's addresses until a connection is established.

### Response Caching

Android 4.0 (Ice Cream Sandwich, API level 15) includes a response cache. See `android.net.http.HttpResponseCache` for instructions on enabling HTTP caching in your application.

### Avoiding Bugs In Earlier Releases

Prior to Android 2.2 (Froyo), this class had some frustrating bugs. In particular, calling `close()` on a readable `InputStream` could [poison the connection pool](http://code.google.com/p/android/issues/detail?id=2939). Work around this by disabling connection pooling:

    private void disableConnectionReuseIfNecessary() {
      // Work around pre-Froyo bugs in HTTP connection reuse.
      if (Integer.parseInt(Build.VERSION.SDK) < Build.VERSION_CODES.FROYO) {
        System.setProperty("http.keepAlive", "false");
      }
    }

Each instance of `HttpURLConnection` may be used for one request/response pair. Instances of this class are not thread safe.
**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#disconnect()`

## Summary

| ### Constants ||
|---|---|
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_ACCEPTED` HTTP Status-Code 202: Accepted. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_BAD_GATEWAY` HTTP Status-Code 502: Bad Gateway. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_BAD_METHOD` HTTP Status-Code 405: Method Not Allowed. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_BAD_REQUEST` HTTP Status-Code 400: Bad Request. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_CLIENT_TIMEOUT` HTTP Status-Code 408: Request Time-Out. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_CONFLICT` HTTP Status-Code 409: Conflict. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_CREATED` HTTP Status-Code 201: Created. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_ENTITY_TOO_LARGE` HTTP Status-Code 413: Request Entity Too Large. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_FORBIDDEN` HTTP Status-Code 403: Forbidden. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_GATEWAY_TIMEOUT` HTTP Status-Code 504: Gateway Timeout. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_GONE` HTTP Status-Code 410: Gone. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_INTERNAL_ERROR` HTTP Status-Code 500: Internal Server Error. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_LENGTH_REQUIRED` HTTP Status-Code 411: Length Required. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_MOVED_PERM` HTTP Status-Code 301: Moved Permanently. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_MOVED_TEMP` HTTP Status-Code 302: Temporary Redirect. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_MULT_CHOICE` HTTP Status-Code 300: Multiple Choices. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NOT_ACCEPTABLE` HTTP Status-Code 406: Not Acceptable. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NOT_AUTHORITATIVE` HTTP Status-Code 203: Non-Authoritative Information. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NOT_FOUND` HTTP Status-Code 404: Not Found. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NOT_IMPLEMENTED` HTTP Status-Code 501: Not Implemented. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NOT_MODIFIED` HTTP Status-Code 304: Not Modified. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_NO_CONTENT` HTTP Status-Code 204: No Content. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_OK` HTTP Status-Code 200: OK. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_PARTIAL` HTTP Status-Code 206: Partial Content. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_PAYMENT_REQUIRED` HTTP Status-Code 402: Payment Required. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_PRECON_FAILED` HTTP Status-Code 412: Precondition Failed. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_PROXY_AUTH` HTTP Status-Code 407: Proxy Authentication Required. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_REQ_TOO_LONG` HTTP Status-Code 414: Request-URI Too Large. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_RESET` HTTP Status-Code 205: Reset Content. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_SEE_OTHER` HTTP Status-Code 303: See Other. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_SERVER_ERROR` *This constant was deprecated in API level 15. it is misplaced and shouldn't have existed.* |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_UNAUTHORIZED` HTTP Status-Code 401: Unauthorized. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_UNAVAILABLE` HTTP Status-Code 503: Service Unavailable. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_UNSUPPORTED_TYPE` HTTP Status-Code 415: Unsupported Media Type. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_USE_PROXY` HTTP Status-Code 305: Use Proxy. |
| `int` | `https://developer.android.com/reference/java/net/HttpURLConnection#HTTP_VERSION` HTTP Status-Code 505: HTTP Version Not Supported. |

| ### Fields ||
|---|---|
| ` protected int` | `https://developer.android.com/reference/java/net/HttpURLConnection#chunkLength` The chunk-length when using chunked encoding streaming mode for output. |
| ` protected int` | `https://developer.android.com/reference/java/net/HttpURLConnection#fixedContentLength` The fixed content-length when using fixed-length streaming mode. |
| ` protected long` | `https://developer.android.com/reference/java/net/HttpURLConnection#fixedContentLengthLong` The fixed content-length when using fixed-length streaming mode. |
| ` protected boolean` | `https://developer.android.com/reference/java/net/HttpURLConnection#instanceFollowRedirects` If `true`, the protocol will automatically follow redirects. |
| ` protected https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/java/net/HttpURLConnection#method` The HTTP method (GET,POST,PUT,etc.). |
| ` protected int` | `https://developer.android.com/reference/java/net/HttpURLConnection#responseCode` An `int` representing the three digit HTTP Status-Code. |
| ` protected https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/java/net/HttpURLConnection#responseMessage` The HTTP response message. |

### Inherited fields

From class `https://developer.android.com/reference/java/net/URLConnection` ` protected boolean` `https://developer.android.com/reference/java/net/URLConnection#allowUserInteraction`

If `true`, this `URL` is being examined in a context in which it makes sense to allow user interactions such as popping up an authentication dialog.
` protected boolean` `https://developer.android.com/reference/java/net/URLConnection#connected`

If `false`, this connection object has not created a communications link to the specified URL.
` protected boolean` `https://developer.android.com/reference/java/net/URLConnection#doInput`

This variable is set by the `setDoInput` method.
` protected boolean` `https://developer.android.com/reference/java/net/URLConnection#doOutput`

This variable is set by the `setDoOutput` method.
` protected long` `https://developer.android.com/reference/java/net/URLConnection#ifModifiedSince`

Some protocols support skipping the fetching of the object unless the object has been modified more recently than a certain time.
` protected https://developer.android.com/reference/java/net/URL` `https://developer.android.com/reference/java/net/URLConnection#url`

The URL represents the remote object on the World Wide Web to which this connection is opened.
` protected boolean` `https://developer.android.com/reference/java/net/URLConnection#useCaches`

If `true`, the protocol is allowed to use caching whenever it can.

| ### Protected constructors ||
|---|---|
| ` https://developer.android.com/reference/java/net/HttpURLConnection#HttpURLConnection(java.net.URL)(https://developer.android.com/reference/java/net/URL u) ` Constructor for the HttpURLConnection. |

| ### Public methods ||
|---|---|
| ` abstract void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#disconnect()() ` Indicates that other requests to the server are unlikely in the near future. |
| ` https://developer.android.com/reference/java/io/InputStream` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getErrorStream()() ` Returns the error stream if the connection failed but the server sent useful data nonetheless. |
| ` static boolean` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getFollowRedirects()() ` Returns a `boolean` indicating whether or not HTTP redirects (3xx) should be automatically followed. |
| ` https://developer.android.com/reference/java/lang/String` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderField(int)(int n) ` Returns the value for the `n`^th^ header field. |
| ` long` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderFieldDate(java.lang.String,%20long)(https://developer.android.com/reference/java/lang/String name, long Default) ` Returns the value of the named field parsed as date. |
| ` https://developer.android.com/reference/java/lang/String` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderFieldKey(int)(int n) ` Returns the key for the `n`^th^ header field. |
| ` boolean` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getInstanceFollowRedirects()() ` Returns the value of this `HttpURLConnection`'s `instanceFollowRedirects` field. |
| ` https://developer.android.com/reference/java/security/Permission` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getPermission()() ` Returns a `https://developer.android.com/reference/java/net/SocketPermission` object representing the permission necessary to connect to the destination host and port. |
| ` https://developer.android.com/reference/java/lang/String` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getRequestMethod()() ` Get the request method. |
| ` int` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getResponseCode()() ` Gets the status code from an HTTP response message. |
| ` https://developer.android.com/reference/java/lang/String` | ` https://developer.android.com/reference/java/net/HttpURLConnection#getResponseMessage()() ` Gets the HTTP response message, if any, returned along with the response code from a server. |
| ` void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setChunkedStreamingMode(int)(int chunklen) ` This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is **not** known in advance. |
| ` void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(int)(int contentLength) ` This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance. |
| ` void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(long)(long contentLength) ` This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance. |
| ` static void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setFollowRedirects(boolean)(boolean set) ` Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this class. |
| ` void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setInstanceFollowRedirects(boolean)(boolean followRedirects) ` Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this `HttpURLConnection` instance. |
| ` void` | ` https://developer.android.com/reference/java/net/HttpURLConnection#setRequestMethod(java.lang.String)(https://developer.android.com/reference/java/lang/String method) ` Set the method for the URL request, one of: - GET - POST - HEAD - OPTIONS - PUT - DELETE - TRACE are legal, subject to protocol restrictions. <br /> |
| ` abstract boolean` | ` https://developer.android.com/reference/java/net/HttpURLConnection#usingProxy()() ` Indicates if the connection is going through a proxy. |

### Inherited methods

From class ` https://developer.android.com/reference/java/net/URLConnection ` ` void` ` https://developer.android.com/reference/java/net/URLConnection#addRequestProperty(java.lang.String,%20java.lang.String)(https://developer.android.com/reference/java/lang/String key, https://developer.android.com/reference/java/lang/String value) `

Adds a general request property specified by a key-value pair.
` abstract void` ` https://developer.android.com/reference/java/net/URLConnection#connect()() `

Opens a communications link to the resource referenced by this URL, if such a connection has not already been established.
` boolean` ` https://developer.android.com/reference/java/net/URLConnection#getAllowUserInteraction()() `

Returns the value of the `allowUserInteraction` field for this object.
` int` ` https://developer.android.com/reference/java/net/URLConnection#getConnectTimeout()() `

Returns setting for connect timeout.
` https://developer.android.com/reference/java/lang/Object` ` https://developer.android.com/reference/java/net/URLConnection#getContent()() `

Retrieves the contents of this URL connection.
` https://developer.android.com/reference/java/lang/Object` ` https://developer.android.com/reference/java/net/URLConnection#getContent(java.lang.Class[])(https://developer.android.com/reference/java/lang/Class classes) `

Retrieves the contents of this URL connection.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getContentEncoding()() `

Returns the value of the `content-encoding` header field.
` int` ` https://developer.android.com/reference/java/net/URLConnection#getContentLength()() `

Returns the value of the `content-length` header field.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getContentLengthLong()() `

Returns the value of the `content-length` header field as a long.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getContentType()() `

Returns the value of the `content-type` header field.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getDate()() `

Returns the value of the `date` header field.
` static boolean` ` https://developer.android.com/reference/java/net/URLConnection#getDefaultAllowUserInteraction()() `

Returns the default value of the `allowUserInteraction` field.
` static https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getDefaultRequestProperty(java.lang.String)(https://developer.android.com/reference/java/lang/String key) `

*This method was deprecated in API level 15. The instance specific getRequestProperty method should be used after an appropriate instance of URLConnection is obtained.*
` boolean` ` https://developer.android.com/reference/java/net/URLConnection#getDefaultUseCaches()() `

Returns the default value of a `URLConnection`'s `useCaches` flag.
` boolean` ` https://developer.android.com/reference/java/net/URLConnection#getDoInput()() `

Returns the value of this `URLConnection`'s `doInput` flag.
` boolean` ` https://developer.android.com/reference/java/net/URLConnection#getDoOutput()() `

Returns the value of this `URLConnection`'s `doOutput` flag.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getExpiration()() `

Returns the value of the `expires` header field.
` static https://developer.android.com/reference/java/net/FileNameMap` ` https://developer.android.com/reference/java/net/URLConnection#getFileNameMap()() `

Returns a `https://developer.android.com/reference/java/net/FileNameMap` implementation suitable for guessing a content type based on a URL's "file" component.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderField(java.lang.String)(https://developer.android.com/reference/java/lang/String name) `

Returns the value of the named header field.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderField(int)(int n) `

Returns the value for the `n`^th^ header field.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderFieldDate(java.lang.String,%20long)(https://developer.android.com/reference/java/lang/String name, long Default) `

Returns the value of the named field parsed as date.
` int` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderFieldInt(java.lang.String,%20int)(https://developer.android.com/reference/java/lang/String name, int Default) `

Returns the value of the named field parsed as a number.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderFieldKey(int)(int n) `

Returns the key for the `n`^th^ header field.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderFieldLong(java.lang.String,%20long)(https://developer.android.com/reference/java/lang/String name, long Default) `

Returns the value of the named field parsed as a number.
` https://developer.android.com/reference/java/util/Map<https://developer.android.com/reference/java/lang/String, https://developer.android.com/reference/java/util/List<https://developer.android.com/reference/java/lang/String>>` ` https://developer.android.com/reference/java/net/URLConnection#getHeaderFields()() `

Returns an unmodifiable Map of the header fields.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getIfModifiedSince()() `

Returns the value of this object's `ifModifiedSince` field.
` https://developer.android.com/reference/java/io/InputStream` ` https://developer.android.com/reference/java/net/URLConnection#getInputStream()() `

Returns an input stream that reads from this open connection.
` long` ` https://developer.android.com/reference/java/net/URLConnection#getLastModified()() `

Returns the value of the `last-modified` header field.
` https://developer.android.com/reference/java/io/OutputStream` ` https://developer.android.com/reference/java/net/URLConnection#getOutputStream()() `

Returns an output stream that writes to this connection.
` https://developer.android.com/reference/java/security/Permission` ` https://developer.android.com/reference/java/net/URLConnection#getPermission()() `

Returns a permission object representing the permission necessary to make the connection represented by this object.
` int` ` https://developer.android.com/reference/java/net/URLConnection#getReadTimeout()() `

Returns setting for read timeout.
` https://developer.android.com/reference/java/util/Map<https://developer.android.com/reference/java/lang/String, https://developer.android.com/reference/java/util/List<https://developer.android.com/reference/java/lang/String>>` ` https://developer.android.com/reference/java/net/URLConnection#getRequestProperties()() `

Returns an unmodifiable Map of general request properties for this connection.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#getRequestProperty(java.lang.String)(https://developer.android.com/reference/java/lang/String key) `

Returns the value of the named general request property for this connection.
` https://developer.android.com/reference/java/net/URL` ` https://developer.android.com/reference/java/net/URLConnection#getURL()() `

Returns the value of this `URLConnection`'s `URL` field.
` boolean` ` https://developer.android.com/reference/java/net/URLConnection#getUseCaches()() `

Returns the value of this `URLConnection`'s `useCaches` field.
` static https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#guessContentTypeFromName(java.lang.String)(https://developer.android.com/reference/java/lang/String fname) `

Tries to determine the content type of an object, based on the specified "file" component of a URL.
` static https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#guessContentTypeFromStream(java.io.InputStream)(https://developer.android.com/reference/java/io/InputStream is) `

Tries to determine the type of an input stream based on the characters at the beginning of the input stream.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setAllowUserInteraction(boolean)(boolean allowuserinteraction) `

Set the value of the `allowUserInteraction` field of this `URLConnection`.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setConnectTimeout(int)(int timeout) `

Sets a specified timeout value, in milliseconds, to be used when opening a communications link to the resource referenced by this URLConnection.
` static void` ` https://developer.android.com/reference/java/net/URLConnection#setContentHandlerFactory(java.net.ContentHandlerFactory)(https://developer.android.com/reference/java/net/ContentHandlerFactory fac) `

Sets the `ContentHandlerFactory` of an application.
` static void` ` https://developer.android.com/reference/java/net/URLConnection#setDefaultAllowUserInteraction(boolean)(boolean defaultallowuserinteraction) `

Sets the default value of the `allowUserInteraction` field for all future `URLConnection` objects to the specified value.
` static void` ` https://developer.android.com/reference/java/net/URLConnection#setDefaultRequestProperty(java.lang.String,%20java.lang.String)(https://developer.android.com/reference/java/lang/String key, https://developer.android.com/reference/java/lang/String value) `

*This method was deprecated in API level 15. The instance specific setRequestProperty method should be used after an appropriate instance of URLConnection is obtained. Invoking this method will have no effect.*
` void` ` https://developer.android.com/reference/java/net/URLConnection#setDefaultUseCaches(boolean)(boolean defaultusecaches) `

Sets the default value of the `useCaches` field to the specified value.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setDoInput(boolean)(boolean doinput) `

Sets the value of the `doInput` field for this `URLConnection` to the specified value.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setDoOutput(boolean)(boolean dooutput) `

Sets the value of the `doOutput` field for this `URLConnection` to the specified value.
` static void` ` https://developer.android.com/reference/java/net/URLConnection#setFileNameMap(java.net.FileNameMap)(https://developer.android.com/reference/java/net/FileNameMap map) `

Sets the FileNameMap.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setIfModifiedSince(long)(long ifmodifiedsince) `

Sets the value of the `ifModifiedSince` field of this `URLConnection` to the specified value.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setReadTimeout(int)(int timeout) `

Sets the read timeout to a specified timeout, in milliseconds.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setRequestProperty(java.lang.String,%20java.lang.String)(https://developer.android.com/reference/java/lang/String key, https://developer.android.com/reference/java/lang/String value) `

Sets the general request property.
` void` ` https://developer.android.com/reference/java/net/URLConnection#setUseCaches(boolean)(boolean usecaches) `

Sets the value of the `useCaches` field of this `URLConnection` to the specified value.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/net/URLConnection#toString()() `

Returns a `String` representation of this URL connection.
From class ` https://developer.android.com/reference/java/lang/Object ` ` https://developer.android.com/reference/java/lang/Object` ` https://developer.android.com/reference/java/lang/Object#clone()() `

Creates and returns a copy of this object.
` boolean` ` https://developer.android.com/reference/java/lang/Object#equals(java.lang.Object)(https://developer.android.com/reference/java/lang/Object obj) `

Indicates whether some other object is "equal to" this one.
` void` ` https://developer.android.com/reference/java/lang/Object#finalize()() `

Called by the garbage collector on an object when garbage collection determines that there are no more references to the object.
` final https://developer.android.com/reference/java/lang/Class<?>` ` https://developer.android.com/reference/java/lang/Object#getClass()() `

Returns the runtime class of this `Object`.
` int` ` https://developer.android.com/reference/java/lang/Object#hashCode()() `

Returns a hash code value for the object.
` final void` ` https://developer.android.com/reference/java/lang/Object#notify()() `

Wakes up a single thread that is waiting on this object's monitor.
` final void` ` https://developer.android.com/reference/java/lang/Object#notifyAll()() `

Wakes up all threads that are waiting on this object's monitor.
` https://developer.android.com/reference/java/lang/String` ` https://developer.android.com/reference/java/lang/Object#toString()() `

Returns a string representation of the object.
` final void` ` https://developer.android.com/reference/java/lang/Object#wait(long,%20int)(long timeoutMillis, int nanos) `

Causes the current thread to wait until it is awakened, typically by being *notified* or *interrupted*, or until a certain amount of real time has elapsed.
` final void` ` https://developer.android.com/reference/java/lang/Object#wait(long)(long timeoutMillis) `

Causes the current thread to wait until it is awakened, typically by being *notified* or *interrupted*, or until a certain amount of real time has elapsed.
` final void` ` https://developer.android.com/reference/java/lang/Object#wait()() `

Causes the current thread to wait until it is awakened, typically by being *notified* or *interrupted*.

## Constants

### HTTP_ACCEPTED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_ACCEPTED
```

HTTP Status-Code 202: Accepted.

<br />

Constant Value: 202 (0x000000ca)

### HTTP_BAD_GATEWAY

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_BAD_GATEWAY
```

HTTP Status-Code 502: Bad Gateway.

<br />

Constant Value: 502 (0x000001f6)

### HTTP_BAD_METHOD

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_BAD_METHOD
```

HTTP Status-Code 405: Method Not Allowed.

<br />

Constant Value: 405 (0x00000195)

### HTTP_BAD_REQUEST

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_BAD_REQUEST
```

HTTP Status-Code 400: Bad Request.

<br />

Constant Value: 400 (0x00000190)

### HTTP_CLIENT_TIMEOUT

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_CLIENT_TIMEOUT
```

HTTP Status-Code 408: Request Time-Out.

<br />

Constant Value: 408 (0x00000198)

### HTTP_CONFLICT

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_CONFLICT
```

HTTP Status-Code 409: Conflict.

<br />

Constant Value: 409 (0x00000199)

### HTTP_CREATED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_CREATED
```

HTTP Status-Code 201: Created.

<br />

Constant Value: 201 (0x000000c9)

### HTTP_ENTITY_TOO_LARGE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_ENTITY_TOO_LARGE
```

HTTP Status-Code 413: Request Entity Too Large.

<br />

Constant Value: 413 (0x0000019d)

### HTTP_FORBIDDEN

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_FORBIDDEN
```

HTTP Status-Code 403: Forbidden.

<br />

Constant Value: 403 (0x00000193)

### HTTP_GATEWAY_TIMEOUT

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_GATEWAY_TIMEOUT
```

HTTP Status-Code 504: Gateway Timeout.

<br />

Constant Value: 504 (0x000001f8)

### HTTP_GONE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_GONE
```

HTTP Status-Code 410: Gone.

<br />

Constant Value: 410 (0x0000019a)

### HTTP_INTERNAL_ERROR

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_INTERNAL_ERROR
```

HTTP Status-Code 500: Internal Server Error.

<br />

Constant Value: 500 (0x000001f4)

### HTTP_LENGTH_REQUIRED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_LENGTH_REQUIRED
```

HTTP Status-Code 411: Length Required.

<br />

Constant Value: 411 (0x0000019b)

### HTTP_MOVED_PERM

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_MOVED_PERM
```

HTTP Status-Code 301: Moved Permanently.

<br />

Constant Value: 301 (0x0000012d)

### HTTP_MOVED_TEMP

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_MOVED_TEMP
```

HTTP Status-Code 302: Temporary Redirect.

<br />

Constant Value: 302 (0x0000012e)

### HTTP_MULT_CHOICE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_MULT_CHOICE
```

HTTP Status-Code 300: Multiple Choices.

<br />

Constant Value: 300 (0x0000012c)

### HTTP_NOT_ACCEPTABLE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NOT_ACCEPTABLE
```

HTTP Status-Code 406: Not Acceptable.

<br />

Constant Value: 406 (0x00000196)

### HTTP_NOT_AUTHORITATIVE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NOT_AUTHORITATIVE
```

HTTP Status-Code 203: Non-Authoritative Information.

<br />

Constant Value: 203 (0x000000cb)

### HTTP_NOT_FOUND

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NOT_FOUND
```

HTTP Status-Code 404: Not Found.

<br />

Constant Value: 404 (0x00000194)

### HTTP_NOT_IMPLEMENTED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NOT_IMPLEMENTED
```

HTTP Status-Code 501: Not Implemented.

<br />

Constant Value: 501 (0x000001f5)

### HTTP_NOT_MODIFIED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NOT_MODIFIED
```

HTTP Status-Code 304: Not Modified.

<br />

Constant Value: 304 (0x00000130)

### HTTP_NO_CONTENT

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_NO_CONTENT
```

HTTP Status-Code 204: No Content.

<br />

Constant Value: 204 (0x000000cc)

### HTTP_OK

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_OK
```

HTTP Status-Code 200: OK.

<br />

Constant Value: 200 (0x000000c8)

### HTTP_PARTIAL

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_PARTIAL
```

HTTP Status-Code 206: Partial Content.

<br />

Constant Value: 206 (0x000000ce)

### HTTP_PAYMENT_REQUIRED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_PAYMENT_REQUIRED
```

HTTP Status-Code 402: Payment Required.

<br />

Constant Value: 402 (0x00000192)

### HTTP_PRECON_FAILED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_PRECON_FAILED
```

HTTP Status-Code 412: Precondition Failed.

<br />

Constant Value: 412 (0x0000019c)

### HTTP_PROXY_AUTH

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_PROXY_AUTH
```

HTTP Status-Code 407: Proxy Authentication Required.

<br />

Constant Value: 407 (0x00000197)

### HTTP_REQ_TOO_LONG

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_REQ_TOO_LONG
```

HTTP Status-Code 414: Request-URI Too Large.

<br />

Constant Value: 414 (0x0000019e)

### HTTP_RESET

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_RESET
```

HTTP Status-Code 205: Reset Content.

<br />

Constant Value: 205 (0x000000cd)

### HTTP_SEE_OTHER

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_SEE_OTHER
```

HTTP Status-Code 303: See Other.

<br />

Constant Value: 303 (0x0000012f)

### HTTP_SERVER_ERROR

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)   
Deprecated in [API level 15](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_SERVER_ERROR
```

<br />

**This constant was deprecated in API level 15.**   

it is misplaced and shouldn't have existed.

HTTP Status-Code 500: Internal Server Error.

<br />

Constant Value: 500 (0x000001f4)

### HTTP_UNAUTHORIZED

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_UNAUTHORIZED
```

HTTP Status-Code 401: Unauthorized.

<br />

Constant Value: 401 (0x00000191)

### HTTP_UNAVAILABLE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_UNAVAILABLE
```

HTTP Status-Code 503: Service Unavailable.

<br />

Constant Value: 503 (0x000001f7)

### HTTP_UNSUPPORTED_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_UNSUPPORTED_TYPE
```

HTTP Status-Code 415: Unsupported Media Type.

<br />

Constant Value: 415 (0x0000019f)

### HTTP_USE_PROXY

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_USE_PROXY
```

HTTP Status-Code 305: Use Proxy.

<br />

Constant Value: 305 (0x00000131)

### HTTP_VERSION

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int HTTP_VERSION
```

HTTP Status-Code 505: HTTP Version Not Supported.

<br />

Constant Value: 505 (0x000001f9)

## Fields

### chunkLength

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected int chunkLength
```

The chunk-length when using chunked encoding streaming mode for output. A value of `-1` means chunked encoding is disabled for output.

<br />

### fixedContentLength

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected int fixedContentLength
```

The fixed content-length when using fixed-length streaming mode. A value of `-1` means fixed-length streaming mode is disabled for output.

**NOTE:** `https://developer.android.com/reference/java/net/HttpURLConnection#fixedContentLengthLong` is recommended instead of this field, as it allows larger content lengths to be set.

<br />

### fixedContentLengthLong

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected long fixedContentLengthLong
```

The fixed content-length when using fixed-length streaming mode. A value of `-1` means fixed-length streaming mode is disabled for output.

<br />

### instanceFollowRedirects

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected boolean instanceFollowRedirects
```

If `true`, the protocol will automatically follow redirects. If `false`, the protocol will not automatically follow redirects.

This field is set by the `setInstanceFollowRedirects` method. Its value is returned by the `getInstanceFollowRedirects` method.

Its default value is based on the value of the static followRedirects at HttpURLConnection construction time.

<br />

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#setInstanceFollowRedirects(boolean)`
- `https://developer.android.com/reference/java/net/HttpURLConnection#getInstanceFollowRedirects()`
- `https://developer.android.com/reference/java/net/HttpURLConnection#setFollowRedirects(boolean)`

### method

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected String method
```

The HTTP method (GET,POST,PUT,etc.).

<br />

### responseCode

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected int responseCode
```

An `int` representing the three digit HTTP Status-Code.

- 1xx: Informational
- 2xx: Success
- 3xx: Redirection
- 4xx: Client Error
- 5xx: Server Error

<br />

<br />

### responseMessage

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected String responseMessage
```

The HTTP response message.

<br />

## Protected constructors

### HttpURLConnection

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
protected HttpURLConnection (URL u)
```

Constructor for the HttpURLConnection.

<br />

| Parameters ||
|---|---|
| `u` | `URL`: the URL <br /> |

## Public methods

### disconnect

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public abstract void disconnect ()
```

Indicates that other requests to the server are unlikely in the near future. Calling disconnect() should not imply that this HttpURLConnection instance can be reused for other requests.

<br />

### getErrorStream

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public InputStream getErrorStream ()
```

Returns the error stream if the connection failed but the server sent useful data nonetheless. The typical example is when an HTTP server responds with a 404, which will cause a FileNotFoundException to be thrown in connect, but the server sent an HTML help page with suggestions as to what to do.

This method will not cause a connection to be initiated. If the connection was not connected, or if the server did not have an error while connecting or if the server had an error but no error data was sent, this method will return null. This is the default.

<br />

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/io/InputStream` | an error stream if any, null if there have been no errors, the connection is not connected or the server sent no useful data. <br /> |

### getFollowRedirects

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static boolean getFollowRedirects ()
```

Returns a `boolean` indicating whether or not HTTP redirects (3xx) should be automatically followed.

<br />

| Returns ||
|---|---|
| `boolean` | `true` if HTTP redirects should be automatically followed, `false` if not. <br /> |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#setFollowRedirects(boolean)`

### getHeaderField

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public String getHeaderField (int n)
```

Returns the value for the `n`^th^ header field. Some implementations may treat the `0`^th^ header field as special, i.e. as the status line returned by the HTTP server.

This method can be used in conjunction with the `https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderFieldKey(int)` method to iterate through all the headers in the message.

<br />

| Parameters ||
|---|---|
| `n` | `int`: an index, where `n>=0`. <br /> |

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/lang/String` | the value of the `n`^th^ header field, or `null` if the value does not exist. <br /> |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderFieldKey(int)`

### getHeaderFieldDate

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public long getHeaderFieldDate (String name, 
                long Default)
```

Returns the value of the named field parsed as date. The result is the number of milliseconds since January 1, 1970 GMT represented by the named field.

This form of `getHeaderField` exists because some connection types (e.g., `http-ng`) have pre-parsed headers. Classes for that connection type can override this method and short-circuit the parsing.

<br />

| Parameters ||
|---|---|
| `name` | `String`: the name of the header field. <br /> |
| `Default` | `long`: a default value. <br /> |

| Returns ||
|---|---|
| `long` | the value of the field, parsed as a date. The value of the `Default` argument is returned if the field is missing or malformed. <br /> |

### getHeaderFieldKey

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public String getHeaderFieldKey (int n)
```

Returns the key for the `n`^th^ header field. Some implementations may treat the `0`^th^ header field as special, i.e. as the status line returned by the HTTP server. In this case, `https://developer.android.com/reference/java/net/HttpURLConnection#getHeaderField(int)` returns the status line, but `getHeaderFieldKey(0)` returns null.

<br />

| Parameters ||
|---|---|
| `n` | `int`: an index, where `n >=0`. <br /> |

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/lang/String` | the key for the `n`^th^ header field, or `null` if the key does not exist. <br /> |

### getInstanceFollowRedirects

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public boolean getInstanceFollowRedirects ()
```

Returns the value of this `HttpURLConnection`'s `instanceFollowRedirects` field.

<br />

| Returns ||
|---|---|
| `boolean` | the value of this `HttpURLConnection`'s `instanceFollowRedirects` field. <br /> |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#instanceFollowRedirects`
- `https://developer.android.com/reference/java/net/HttpURLConnection#setInstanceFollowRedirects(boolean)`

### getPermission

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public Permission getPermission ()
```

Returns a `https://developer.android.com/reference/java/net/SocketPermission` object representing the permission necessary to connect to the destination host and port.

<br />

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/security/Permission` | a `SocketPermission` object representing the permission necessary to connect to the destination host and port. <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/io/IOException` | if an error occurs while computing the permission. |

### getRequestMethod

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public String getRequestMethod ()
```

Get the request method.

<br />

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/lang/String` | the HTTP request method <br /> |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#setRequestMethod(java.lang.String)`

### getResponseCode

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public int getResponseCode ()
```

Gets the status code from an HTTP response message. For example, in the case of the following status lines:

```
HTTP/1.0 200 OK
HTTP/1.0 401 Unauthorized
```
It will return 200 and 401 respectively. Returns -1 if no code can be discerned from the response (i.e., the response is not valid HTTP).

<br />

<br />

| Returns ||
|---|---|
| `int` | the HTTP Status-Code, or -1 <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/io/IOException` | if an error occurred connecting to the server. |

### getResponseMessage

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public String getResponseMessage ()
```

Gets the HTTP response message, if any, returned along with the response code from a server. From responses like:

```
HTTP/1.0 200 OK
HTTP/1.0 404 Not Found
```
Extracts the Strings "OK" and "Not Found" respectively. Returns null if none could be discerned from the responses (the result was not valid HTTP).

<br />

<br />

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/lang/String` | the HTTP response message, or `null` <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/io/IOException` | if an error occurred connecting to the server. |

### setChunkedStreamingMode

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public void setChunkedStreamingMode (int chunklen)
```

This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is **not** known in advance. In this mode, chunked transfer encoding is used to send the request body. Note, not all HTTP servers support this mode.

When output streaming is enabled, authentication and redirection cannot be handled automatically. A HttpRetryException will be thrown when reading the response if authentication or redirection are required. This exception can be queried for the details of the error.

This method must be called before the URLConnection is connected.

<br />

| Parameters ||
|---|---|
| `chunklen` | `int`: The number of bytes to write in each chunk. If chunklen is less than or equal to zero, a default value will be used. <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/lang/IllegalStateException` | if URLConnection is already connected or if a different streaming mode is already enabled. |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(int)`

### setFixedLengthStreamingMode

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public void setFixedLengthStreamingMode (int contentLength)
```

This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance.

An exception will be thrown if the application attempts to write more data than the indicated content-length, or if the application closes the OutputStream before writing the indicated amount.

When output streaming is enabled, authentication and redirection cannot be handled automatically. A HttpRetryException will be thrown when reading the response if authentication or redirection are required. This exception can be queried for the details of the error.

This method must be called before the URLConnection is connected.

**NOTE:** `https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(long)` is recommended instead of this method as it allows larger content lengths to be set.

<br />

| Parameters ||
|---|---|
| `contentLength` | `int`: The number of bytes which will be written to the OutputStream. <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/lang/IllegalArgumentException` | if a content length less than zero is specified. |
| `https://developer.android.com/reference/java/lang/IllegalStateException` | if URLConnection is already connected or if a different streaming mode is already enabled. |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#setChunkedStreamingMode(int)`

### setFixedLengthStreamingMode

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public void setFixedLengthStreamingMode (long contentLength)
```

This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance.

An exception will be thrown if the application attempts to write more data than the indicated content-length, or if the application closes the OutputStream before writing the indicated amount.

When output streaming is enabled, authentication and redirection cannot be handled automatically. A [HttpRetryException](https://developer.android.com/reference/java/net/HttpRetryException) will be thrown when reading the response if authentication or redirection are required. This exception can be queried for the details of the error.

This method must be called before the URLConnection is connected.

The content length set by invoking this method takes precedence over any value set by `https://developer.android.com/reference/java/net/HttpURLConnection#setFixedLengthStreamingMode(int)`.

<br />

| Parameters ||
|---|---|
| `contentLength` | `long`: The number of bytes which will be written to the OutputStream. <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/lang/IllegalArgumentException` | if a content length less than zero is specified. |
| `https://developer.android.com/reference/java/lang/IllegalStateException` | if URLConnection is already connected or if a different streaming mode is already enabled. |

### setFollowRedirects

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static void setFollowRedirects (boolean set)
```

Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this class. True by default. Applets cannot change this variable.

If there is a security manager, this method first calls the security manager's `checkSetFactory` method to ensure the operation is allowed. This could result in a SecurityException.

<br />

| Parameters ||
|---|---|
| `set` | `boolean`: a `boolean` indicating whether or not to follow HTTP redirects. <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/lang/SecurityException` | if a security manager exists and its `checkSetFactory` method doesn't allow the operation. |

**See also:**

- `https://developer.android.com/reference/java/lang/SecurityManager#checkSetFactory()`
- `https://developer.android.com/reference/java/net/HttpURLConnection#getFollowRedirects()`

### setInstanceFollowRedirects

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public void setInstanceFollowRedirects (boolean followRedirects)
```

Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this `HttpURLConnection` instance.

The default value comes from followRedirects, which defaults to true.

<br />

| Parameters ||
|---|---|
| `followRedirects` | `boolean`: a `boolean` indicating whether or not to follow HTTP redirects. <br /> |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#instanceFollowRedirects`
- `https://developer.android.com/reference/java/net/HttpURLConnection#getInstanceFollowRedirects()`

### setRequestMethod

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public void setRequestMethod (String method)
```

Set the method for the URL request, one of:

- GET
- POST
- HEAD
- OPTIONS
- PUT
- DELETE
- TRACE

are legal, subject to protocol restrictions. The default method is GET.

<br />

<br />

| Parameters ||
|---|---|
| `method` | `String`: the HTTP method <br /> |

| Throws ||
|---|---|
| `https://developer.android.com/reference/java/lang/SecurityException` | if a security manager is set and the method is "TRACE", but the "allowHttpTrace" NetPermission is not granted. |
| `https://developer.android.com/reference/java/net/ProtocolException` | if the method cannot be reset or if the requested method isn't valid for HTTP. |

**See also:**

- `https://developer.android.com/reference/java/net/HttpURLConnection#getRequestMethod()`

### usingProxy

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public abstract boolean usingProxy ()
```

Indicates if the connection is going through a proxy.

<br />

| Returns ||
|---|---|
| `boolean` | a boolean indicating if the connection is using a proxy. <br /> |